﻿#!/usr/bin/perl -w
# perl PerlScript.pl infile.fas > outfile

use strict;
use warnings;

my $inFileName = $ARGV[0];

my $name = "";
my $seq = "";

my @fileCont1 = ( );
my @fileCont2 = ( );
my @SeqNames = ( );
my @SeqArrayPdis = ( );
my @compareI = ( );
my @compareJ = ( );

my %fasHash = ( );

my $count = 0;
my $pdist = 0;
my $length = 0;
my $formated = 0;
my $mileStone = 0;


############## nameline を @SeqNames に格納する．
open (INFILE,"$inFileName");
@fileCont1 = <INFILE>;
close(INFILE);

foreach my $inFileLine1 (@fileCont1) {
  chomp($inFileLine1);
  if($inFileLine1 =~ /^>/){
    $inFileLine1 =~ s/>//;
    push(@SeqNames,$inFileLine1);
  }
}

# print "@SeqNames\n";


############# fasta 形式を %fasHash に格納する．
open (INFILE,"$inFileName");
@fileCont2 = <INFILE>;
close(INFILE);

foreach my $inFileLine2 (@fileCont2) {
  chomp($inFileLine2);
  if($inFileLine2 =~ /^>/){
    $inFileLine2 =~ s/>//;
    if ($mileStone == 0) {
       $name = $inFileLine2;
       $mileStone = 1;
    } else {
       # print "$name\n";
       # print "$seq\n";
       $fasHash{$name} = $seq; 
       $name = "";
       $seq = "";
       $name = $inFileLine2;
    }
  } else {
    $seq .= $inFileLine2;
  }
}

# print "$name\n";
# print "$seq\n";
$fasHash{$name} = $seq;
$length = length$seq;
$name = "";
$seq = "";
$mileStone = 0;

## fasHash のプリントアウト
#foreach my $pname (keys %fasHash) {
#  print "key: $pname \nvalue: $fasHash{$pname}\n\n";
#}


## P distance の計算

# %fasHash の value を @SeqNames の順序に従って @SeqArrayPdis に格納する．
foreach my $sname (@SeqNames) {
  push(@SeqArrayPdis,$fasHash{$sname});
}
# print "@SeqArrayPdis\n";

for(my $i=0; $i < scalar@SeqNames; $i++) {

   for(my $j=0; $j < scalar@SeqNames; $j++){
     @compareI = split(//,$SeqArrayPdis[$i]);
     @compareJ = split(//,$SeqArrayPdis[$j]);
     
#     print "$SeqNames[$i]:\n".join('',@compareI)."\n";     
#     print "$SeqNames[$j]:\n".join('',@compareJ)."\n";

     for(my $k=0; $k < scalar@compareI;$k++){
       if($compareI[$k] ne $compareJ[$k]){
         $count++;
       }
     }

    $SeqNames[$i] =~ s/\_.*$//;
    $SeqNames[$j] =~ s/\_.*$//;
    print "$SeqNames[$i] vs $SeqNames[$j]\t";
     

    $pdist = $count/scalar@compareI;
    $formated = sprintf( "%.3f", $pdist);   # 小数点 3 桁で表示
    print "Seq Lenght: $length;\tDif sites: $count;\tP dist: $formated\n";

    @compareI = ( );
    @compareJ = ( );
    $count = 0;    
    $pdist = 0;
  }
  print "\n";
} 
$length = 0;
  

exit;